Loading...
Searching...
No Matches
juce::SynthesiserVoice Class Referenceabstract

## Detailed Description

Represents a voice that a Synthesiser can use to play a SynthesiserSound.

A voice plays a single sound at a time, and a synthesiser holds an array of voices so that it can play polyphonically.

See also
  Synthesiser, SynthesiserSound

The documentation for this class was generated from the following file:

- juce_audio_basics/synthesisers/juce_Synthesiser.h

Inheritance diagram for juce::SynthesiserVoice:

## Public Member Functions

| SynthesiserVoice ()
| Creates a voice.
virtual | ~SynthesiserVoice ()
| Destructor.
int | getCurrentlyPlayingNote () const noexcept
| Returns the midi note that this voice is currently playing.
SynthesiserSound::Ptr | getCurrentlyPlayingSound () const noexcept
| Returns the sound that this voice is currently playing.
virtual bool | canPlaySound (SynthesiserSound *)=0
| Must return true if this voice object is capable of playing the given sound.
virtual void | startNote (int midiNoteNumber, float velocity, SynthesiserSound *sound, int currentPitchWheelPosition)=0
| Called to start a new note.
virtual void | stopNote (float velocity, bool allowTailOff)=0
| Called to stop a note.
virtual bool | isVoiceActive () const
| Returns true if this voice is currently busy playing a sound.
virtual void | pitchWheelMoved (int newPitchWheelValue)=0
| Called to let the voice know that the pitch wheel has been moved.
virtual void | controllerMoved (int controllerNumber, int newControllerValue)=0
| Called to let the voice know that a midi controller has been moved.
virtual void | aftertouchChanged (int newAftertouchValue)
| Called to let the voice know that the aftertouch has changed.
virtual void | channelPressureChanged (int newChannelPressureValue)
| Called to let the voice know that the channel pressure has changed.
virtual void | renderNextBlock (AudioBuffer< float > &outputBuffer, int startSample, int numSamples)=0
| Renders the next block of data for this voice.
virtual void | renderNextBlock (AudioBuffer< double > &outputBuffer, int startSample, int numSamples)
| A double-precision version of renderNextBlock().
virtual void | setCurrentPlaybackSampleRate (double newRate)
| Changes the voice's reference sample rate.
virtual bool | isPlayingChannel (int midiChannel) const
| Returns true if the voice is currently playing a sound which is mapped to the given midi channel.
double | getSampleRate () const noexcept
| Returns the current target sample rate at which rendering is being done.
bool | isKeyDown () const noexcept
| Returns true if the key that triggered this voice is still held down.
void | setKeyDown (bool isNowDown) noexcept
| Allows you to modify the flag indicating that the key that triggered this voice is still held down.
bool | isSustainPedalDown () const noexcept
| Returns true if the sustain pedal is currently active for this voice.
void | setSustainPedalDown (bool isNowDown) noexcept
| Modifies the sustain pedal flag.
bool | isSostenutoPedalDown () const noexcept
| Returns true if the sostenuto pedal is currently active for this voice.
void | setSostenutoPedalDown (bool isNowDown) noexcept
| Modifies the sostenuto pedal flag.
bool | isPlayingButReleased () const noexcept
| Returns true if a voice is sounding in its release phase.
bool | wasStartedBefore (const SynthesiserVoice &other) const noexcept
| Returns true if this voice started playing its current note before the other voice did.

## Protected Member Functions

void | clearCurrentNote ()
| Resets the state of this voice after a sound has finished playing.

## Constructors and Destructors

## SynthesiserVoice()

juce::SynthesiserVoice::SynthesiserVoice | ( |  | ) |

Creates a voice.

Referenced by Synthesiser, and wasStartedBefore().

## ~SynthesiserVoice()

virtual juce::SynthesiserVoice::~SynthesiserVoice | ( |  | ) |

virtual

Destructor.

## Member Functions

## getCurrentlyPlayingNote()

int juce::SynthesiserVoice::getCurrentlyPlayingNote | ( |  | ) | const

inline noexcept

Returns the midi note that this voice is currently playing.

Returns a value less than 0 if no note is playing.

## getCurrentlyPlayingSound()

SynthesiserSound::Ptr juce::SynthesiserVoice::getCurrentlyPlayingSound | ( |  | ) | const

inline noexcept

Returns the sound that this voice is currently playing.

Returns nullptr if it's not playing.

## canPlaySound()

virtual bool juce::SynthesiserVoice::canPlaySound | ( | SynthesiserSound * |  | ) |

pure virtual

Must return true if this voice object is capable of playing the given sound.

If there are different classes of sound, and different classes of voice, a voice can choose which ones it wants to take on.

A typical implementation of this method may just return true if there's only one type of voice and sound, or it might check the type of the sound object passed-in and see if it's one that it understands.

Implemented in juce::SamplerVoice.

## startNote()

virtual void juce::SynthesiserVoice::startNote | ( | int | midiNoteNumber,
|  | float | velocity,
|  | SynthesiserSound * | sound,
|  | int | currentPitchWheelPosition )

pure virtual

Called to start a new note.

This will be called during the rendering callback, so must be fast and thread-safe.

Implemented in juce::SamplerVoice.

## stopNote()

virtual void juce::SynthesiserVoice::stopNote | ( | float | velocity,
|  | bool | allowTailOff )

pure virtual

Called to stop a note.

This will be called during the rendering callback, so must be fast and thread-safe.

The velocity indicates how quickly the note was released - 0 is slowly, 1 is quickly.

If allowTailOff is false or the voice doesn't want to tail-off, then it must stop all sound immediately, and must call clearCurrentNote() to reset the state of this voice and allow the synth to reassign it another sound.

If allowTailOff is true and the voice decides to do a tail-off, then it's allowed to begin fading out its sound, and it can stop playing until it's finished. As soon as it finishes playing (during the rendering callback), it must make sure that it calls clearCurrentNote().

Implemented in juce::SamplerVoice.

## isVoiceActive()

virtual bool juce::SynthesiserVoice::isVoiceActive | ( |  | ) | const

virtual

Returns true if this voice is currently busy playing a sound.

By default this just checks the getCurrentlyPlayingNote() value, but can be overridden for more advanced checking.

Referenced by isPlayingButReleased().

## pitchWheelMoved()

virtual void juce::SynthesiserVoice::pitchWheelMoved | ( | int | newPitchWheelValue | ) |

pure virtual

Called to let the voice know that the pitch wheel has been moved.

This will be called during the rendering callback, so must be fast and thread-safe.

Implemented in juce::SamplerVoice.

## controllerMoved()

virtual void juce::SynthesiserVoice::controllerMoved | ( | int | controllerNumber,
|  | int | newControllerValue )

pure virtual

Called to let the voice know that a midi controller has been moved.

This will be called during the rendering callback, so must be fast and thread-safe.

Implemented in juce::SamplerVoice.

## aftertouchChanged()

virtual void juce::SynthesiserVoice::aftertouchChanged | ( | int | newAftertouchValue | ) |

virtual

Called to let the voice know that the aftertouch has changed.

This will be called during the rendering callback, so must be fast and thread-safe.

## channelPressureChanged()

virtual void juce::SynthesiserVoice::channelPressureChanged | ( | int | newChannelPressureValue | ) |

virtual

Called to let the voice know that the channel pressure has changed.

This will be called during the rendering callback, so must be fast and thread-safe.

## renderNextBlock() [1/2]

virtual void juce::SynthesiserVoice::renderNextBlock | ( | AudioBuffer< float > & | outputBuffer,
|  | int | startSample,
|  | int | numSamples )

pure virtual

Renders the next block of data for this voice.

The output audio data must be added to the current contents of the buffer provided. Only the region of the buffer between startSample and (startSample + numSamples) should be altered by this method.

If the voice is currently silent, it should just return without doing anything.

If the sound that the voice is playing finishes during the course of this rendered block, it must call clearCurrentNote(), to tell the synthesiser that it has finished.

The size of the blocks that are rendered can change each time it is called, and may involve rendering as little as 1 sample at a time. In between rendering callbacks, the voice's methods will be called to tell it about note and controller events.

Implemented in juce::SamplerVoice.

Referenced by juce::SamplerVoice::renderNextBlock().

## renderNextBlock() [2/2]

virtual void juce::SynthesiserVoice::renderNextBlock | ( | AudioBuffer< double > & | outputBuffer,
|  | int | startSample,
|  | int | numSamples )

virtual

A double-precision version of renderNextBlock().

Reimplemented in juce::SamplerVoice.

## setCurrentPlaybackSampleRate()

virtual void juce::SynthesiserVoice::setCurrentPlaybackSampleRate | ( | double | newRate | ) |

virtual

Changes the voice's reference sample rate.

The rate is set so that subclasses know the output rate and can set their pitch accordingly.

This method is called by the synth, and subclasses can access the current rate with the currentSampleRate member.

## isPlayingChannel()

virtual bool juce::SynthesiserVoice::isPlayingChannel | ( | int | midiChannel | ) | const

virtual

Returns true if the voice is currently playing a sound which is mapped to the given midi channel.

If it's not currently playing, this will return false.

## getSampleRate()

double juce::SynthesiserVoice::getSampleRate | ( |  | ) | const

inline noexcept

Returns the current target sample rate at which rendering is being done.

Subclasses may need to know this so that they can pitch things correctly.

## isKeyDown()

bool juce::SynthesiserVoice::isKeyDown | ( |  | ) | const

inline noexcept

Returns true if the key that triggered this voice is still held down.

Note that the voice may still be playing after the key was released (e.g because the sostenuto pedal is down).

Referenced by isPlayingButReleased().

## setKeyDown()

void juce::SynthesiserVoice::setKeyDown | ( | bool | isNowDown | ) |

inline noexcept

Allows you to modify the flag indicating that the key that triggered this voice is still held down.

See also
  isKeyDown

## isSustainPedalDown()

bool juce::SynthesiserVoice::isSustainPedalDown | ( |  | ) | const

inline noexcept

Returns true if the sustain pedal is currently active for this voice.

Referenced by isPlayingButReleased().

## setSustainPedalDown()

void juce::SynthesiserVoice::setSustainPedalDown | ( | bool | isNowDown | ) |

inline noexcept

Modifies the sustain pedal flag.

## isSostenutoPedalDown()

bool juce::SynthesiserVoice::isSostenutoPedalDown | ( |  | ) | const

inline noexcept

Returns true if the sostenuto pedal is currently active for this voice.

Referenced by isPlayingButReleased().

## setSostenutoPedalDown()

void juce::SynthesiserVoice::setSostenutoPedalDown | ( | bool | isNowDown | ) |

inline noexcept

Modifies the sostenuto pedal flag.

## isPlayingButReleased()

bool juce::SynthesiserVoice::isPlayingButReleased | ( |  | ) | const

inline noexcept

Returns true if a voice is sounding in its release phase.

References isKeyDown(), isSostenutoPedalDown(), isSustainPedalDown(), and isVoiceActive().

## wasStartedBefore()

bool juce::SynthesiserVoice::wasStartedBefore | ( | const SynthesiserVoice & | other | ) | const

noexcept

Returns true if this voice started playing its current note before the other voice did.

References SynthesiserVoice().

## clearCurrentNote()

void juce::SynthesiserVoice::clearCurrentNote | ( |  | ) |

protected

Resets the state of this voice after a sound has finished playing.

The subclass must call this when it finishes playing a note and becomes available to play new ones.

It must either call it in the stopNote() method, or if the voice is tailing off, then it should call it later during the renderNextBlock method, as soon as it finishes its tail-off.

It can also be called at any time during the render callback if the sound happens to have finished, e.g. if it's playing a sample and the sample finishes.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited